Codeforces Round #334 (Div. 2) B. More Cowbell

題目鏈接:http://codeforces.com/contest/604/problem/B

Description

Kevin Sun wants to move his precious collection of n cowbells from Naperthrill to Exeter, where there is actually grass instead of corn. Before moving, he must pack his cowbells into k boxes of a fixed size. In order to keep his collection safe during transportation, he won't place more than two cowbells into a single box. Since Kevin wishes to minimize expenses, he is curious about the smallest size box he can use to pack his entire collection.

Kevin is a meticulous cowbell collector and knows that the size of his i-th (1 ≤ i ≤ n) cowbell is an integer si. In fact, he keeps his cowbells sorted by size, so si - 1 ≤ si for any i > 1. Also an expert packer, Kevin can fit one or two cowbells into a box of size s if and only if the sum of their sizes does not exceed s. Given this information, help Kevin determine the smallest s for which it is possible to put all of his cowbells into k boxes of size s.

Input

The first line of the input contains two space-separated integers n and k (1 ≤ n ≤ 2·k ≤ 100 000), denoting the number of cowbells and the number of boxes, respectively.

The next line contains n space-separated integers s1, s2, ..., sn (1 ≤ s1 ≤ s2 ≤ ... ≤ sn ≤ 1 000 000), the sizes of Kevin's cowbells. It is guaranteed that the sizes si are given in non-decreasing order.

Output

Print a single integer, the smallest s for which it is possible for Kevin to put all of his cowbells into k boxes of size s.

Sample test(s)
Input
2 1
2 5
Output
7
Input
4 3
2 3 5 9
Output
9
Input
3 2
3 5 7
Output
8
Note

In the first sample, Kevin must pack his two cowbells into the same box.

In the second sample, Kevin can pack together the following sets of cowbells: {2, 3}, {5} and {9}.

In the third sample, the optimal solution is {3, 5} and {7}.

害羞二分+貪心

題意:n個物品放入k個盒子中,每個盒子最多放入兩個物品,要求物品權值小於盒子的權值才能放入,求將物品全部放入盒子時盒子的最小權值是多少。

數據:(1 ≤ n ≤ 2·k ≤ 100 000)

解題方法:二分+貪心

#include<stdio.h>
#include<algorithm>
using namespace std;
long long int s[100100],n,k;
int check(int x)
{
    long long int xx=1,yy=n,ans=0,i;
    for(i=1;i<=n;i++)
    if(x<s[i]) return 0;//單個物品超過x顯然是不合理的
    while(1)
    {
        if(xx>yy) break;
        if(s[xx]+s[yy]>x)
        {
            yy--;ans++;
        }//如果兩個物品相加大於x,那麼這個大物品單獨放在一個盒子裏
        else
        {
            ans++; xx++;yy--;
        }
    }
    if(ans<=k) return 1;
    else return 0;
}
int main()
{
    long long int i,j;
    while(scanf("%lld%lld",&n,&k)!=EOF)
    {
      for(i=1;i<=n;i++)
      scanf("%lld",&s[i]);
      long long int l=1,r=2*1000000,mid;
      while(l<=r)
      {
          mid=(r+l)/2;
          if(check(mid)) r=mid-1;
          else l=mid+1;
      }
      printf("%lld\n",l);//注意輸出的是l
    }
}




發表評論
所有評論
還沒有人評論,想成為第一個評論的人麼? 請在上方評論欄輸入並且點擊發布.
相關文章